#!/usr/bin/env node

const VideoDirectotron = require("./lib/videodirect");

const parseArgs = require('minimist');
const arguments = parseArgs(process.argv);
require('dotenv').config();

(async () => {
  const client = new VideoDirectotron();
  await client.startRecording();

  try {
    let result = {};
    switch (arguments.a) {
      case "signIn":
        result = await client.signIn();
        break;
      case "findEpisode":
        result = await client.findEpisode(arguments.s, arguments.n);
        break;
      case "findAllEpisodesBySeason":
        result = await client.findAllEpisodesBySeason(arguments.s);
        break;
      case "findAllEpisodesBySeasons":
        result = await client.findAllEpisodesBySeasons(arguments.s.split(",").map((elem) => elem.replace(/^\s+|\s+$/g, '')));
        break;
      case "getMonthlyReport":
        result = await client.getMonthlyReport(arguments.y, arguments.m);
        break;
      case "getMonthlyFinancialReport":
        result = await client.getMonthlyFinancialReport(arguments.y, arguments.m);
        break;
      case "createEpisode":
        result = await client.createEpisode(arguments.s, arguments.t, arguments.d, arguments.r, arguments.m, arguments.l, arguments.c, arguments.f, arguments.i, arguments.b)
        break;
    }
    console.log(JSON.stringify({ result, record: await client.stopRecording() }));
  }
  catch (err) {
    console.log(JSON.stringify({ error: err.message, record: await client.stopRecording() }));
  }
  finally {
    await client.close();
  }
})();
